Improved test framework and test for hardlink handling
[rsync/rsync.git] / testsuite / rsync.fns
index 369d38c..2d27a8c 100644 (file)
 TMP="$scratchdir"
 FROM=${TMP}/from
 TO=${TMP}/to
-F1=text1
 LOG=${TMP}/log
 RSYNC="$rsync_bin"
 
 runtest() {
     echo $ECHO_N "Test $1: $ECHO_C"
-    eval "$2"
+    if eval "$2"
+    then
+       echo "${ECHO_T} done."
+       return 0
+    else
+       echo "${ECHO_T} failed!"
+       return 1
+    fi
 }
 
 printmsg() {
@@ -35,10 +41,20 @@ printmsg() {
 }
 
 
+rsync_ls_lR() {
+    find "$@" -print | sort | xargs $TLS
+}
+
+
 ####################
 # Build test directories TO and FROM, with FROM full of files.
 
 hands_setup() {
+    # Clean before creation
+    rm -rf $FROM
+    rm -rf $TO
+
+    [ -d $TMP ] || mkdir $TMP
     [ -d $FROM ] || mkdir $FROM
     [ -d $TO ] || mkdir $TO
 
@@ -56,23 +72,60 @@ hands_setup() {
     touch ${FROM}/empty
     mkdir ${FROM}/emptydir
 
-    # a few hundred lines of test
-    ls -lR / | head -200 > ${FROM}/filelist
+    # a hundred lines of text or so
+    rsync_ls_lR "${srcdir}" > ${FROM}/filelist
 
     # This might fail on systems that don't have -n
     echo $ECHO_N "This file has no trailing lf$ECHO_C" > ${FROM}/nolf
     umask 0
     ln -s nolf ${FROM}/nolf-symlink
-    umask 077
+    umask 022
 
-    cat $srcdir/*.c | head -2000 > ${FROM}/${F1}
+    cat $srcdir/*.c > ${FROM}/text
     mkdir ${FROM}/dir
-    cp ${FROM}/${F1} ${FROM}/dir
+    cp ${FROM}/text ${FROM}/dir
     mkdir ${FROM}/dir/subdir
     mkdir ${FROM}/dir/subdir/subsubdir
     ls -ltr /etc > ${FROM}/dir/subdir/subsubdir/etc-ltr-list
     mkdir ${FROM}/dir/subdir/subsubdir2
     ls -lt /bin > ${FROM}/dir/subdir/subsubdir2/bin-lt-list
+
+#      echo testing head:
+#      ls -lR ${srcdir} | head -10 || echo failed
+}
+
+
+hands_cleanup() {
+    rm -r "$TMP"
+}
+
+
+
+
+####################
+# Many machines do not have "mkdir -p", so we have to build up long paths.
+# How boring.  
+makepath () {
+    echo "        makepath $1"
+    p="$1"
+    (
+       # Absolut Unix.
+       if echo $p | grep '^/' >/dev/null
+       then
+           cd /
+       fi
+    
+       # This will break if $1 contains a space.
+       for c in `echo $p | tr '/' ' '`
+       do 
+           if [ -d "$c" ] || mkdir "$c" 
+           then
+               cd "$c" || return $?
+           else
+               echo "failed to create $c" >&2; return $?
+           fi
+       done
+    )
 }
 
 
@@ -82,37 +135,31 @@ hands_setup() {
 # there are any difference.  If there are, explain them.
 
 checkit() {
-    log=${LOG}
     failed=
-    # the log accumulates all output; we only display it if there 
-    # is a problem.
 
-    echo "Running: \"$1\""  >${log}
-    echo "">>${log}
-    eval "$1"  >>${log} 2>&1
+    # We can just write everything to stdout/stderr, because the
+    # wrapper hides it unless there is a problem.
+
+    echo "Running: \"$1\""  
+    eval "$1" 
     status=$?
     if [ $status != 0 ]; then
        failed="YES";
     fi
 
-    echo "-------------">>${log}
-    echo "check how the files compare with diff:">>${log}
-    echo "">>${log}
-    diff -cr $2 $3 >>${log} 2>&1 || failed=YES
-    echo "-------------">>${log}
-    echo "check how the directory listings compare with diff:">>${log}
-    echo "">>${log}
-    ( cd $2 ; ls -laR ) > ${TMP}/ls-from 2>>${log}
-    ( cd $3 ; ls -laR ) > ${TMP}/ls-to  2>>${log}
-    diff -c ${TMP}/ls-from ${TMP}/ls-to >>${log} 2>&1 || failed=YES
+    echo "-------------"
+    echo "check how the files compare with diff:"
+    echo ""
+    diff -cr $2 $3 || failed=YES
+    echo "-------------"
+    echo "check how the directory listings compare with diff:"
+    echo ""
+    ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from 
+    ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to 
+    diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
     if [ -z "${failed}" ] ; then
-       echo "${ECHO_T} done."
-       rm $log
        return 0
     else
-       echo "${ECHO_T} failed!"
-       cat ${log}
-       rm ${log}
        return 1
     fi
 }
@@ -159,3 +206,21 @@ EOF
 }
 
 
+build_symlinks() {
+    fromdir="$scratchdir/from"
+    todir="$scratchdir/to"
+    mkdir "$fromdir"
+    date >"$fromdir/referent"
+    ln -s referent "$fromdir/relative"
+    ln -s "$fromdir/referent" "$fromdir/absolute"
+    ln -s nonexistent "$fromdir/dangling"
+    ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
+}
+
+test_fail() {
+    echo "$@" >&2
+    exit 1
+}
+
+# be reproducible
+umask 077
\ No newline at end of file